View Javadoc

    1   /*
    2    * $Id: ReflectorLoader.java,v 1.1 2006/05/30 18:27:48 blackdrag Exp $
    3    *
    4    * Copyright 2003 (C) Jochen Theodorou. All Rights Reserved.
    5    *
    6    * Redistribution and use of this software and associated documentation
    7    * ("Software"), with or without modification, are permitted provided that the
    8    * following conditions are met: 1. Redistributions of source code must retain
    9    * copyright statements and notices. Redistributions must also contain a copy
    10   * of this document. 2. Redistributions in binary form must reproduce the above
    11   * copyright notice, this list of conditions and the following disclaimer in
    12   * the documentation and/or other materials provided with the distribution. 3.
    13   * The name "groovy" must not be used to endorse or promote products derived
    14   * from this Software without prior written permission of The Codehaus. For
    15   * written permission, please contact info@codehaus.org. 4. Products derived
    16   * from this Software may not be called "groovy" nor may "groovy" appear in
    17   * their names without prior written permission of The Codehaus. "groovy" is a
    18   * registered trademark of The Codehaus. 5. Due credit should be given to The
    19   * Codehaus - http://groovy.codehaus.org/
    20   *
    21   * THIS SOFTWARE IS PROVIDED BY THE CODEHAUS AND CONTRIBUTORS ``AS IS'' AND ANY
    22   * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
    23   * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    24   * DISCLAIMED. IN NO EVENT SHALL THE CODEHAUS OR ITS CONTRIBUTORS BE LIABLE FOR
    25   * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
    26   * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
    27   * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
    28   * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
    29   * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
    30   * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
    31   * DAMAGE.
    32   *
    33   */
    34  package org.codehaus.groovy.runtime;
    35
    36  import java.security.ProtectionDomain;
    37
    38  /***
    39   * Reflector creation helper. This class is used to define the Refloctor classes.
    40   * For each ClassLoader such a Loader will be created by the MetaClass.
    41   * The only special about this loader is, that it knows the class Reflector,
    42   * which is the base class of all runtime created Reflectors.
    43   *
    44   * @author <a href="mailto:blackdrag@gmx.org">Jochen Theodorou</a>
    45   * @version $Revision: 1.1 $
    46   */
    47  public class ReflectorLoader extends ClassLoader {
    48      /***
    49       * returns the Reflector class.
    50       *
    51       * @return the Reflector class if the name matches
    52       * @throws ClassNotFoundException if the name is not matching Reflector
    53       * @see Reflector
    54       */
    55      protected Class findClass(String name) throws ClassNotFoundException {
    56          if (delegatationLoader==null) return super.loadClass(name);
    57          return delegatationLoader.loadClass(name);
    58      }
    59
    60      /***
    61       * helper method to define Reflector classes
    62       * @param name of the Reflector
    63       * @param bytecode the bytecode
    64       * @param domain  the protection domain
    65       * @return the generated class
    66       */
    67      public Class defineClass(String name, byte[] bytecode, ProtectionDomain domain) {
    68          Class c = defineClass(name, bytecode, 0, bytecode.length, domain);
    69          resolveClass(c);
    70          return c;
    71      }
    72
    73      /***
    74       * creates a RelfectorLoader.
    75       * @param parent the parent loader. This should never be null!
    76       */
    77      public ReflectorLoader(ClassLoader parent) {
    78          super(parent!=null?parent:getSystemClassLoader());
    79          delegatationLoader = getClass().getClassLoader();
    80      }
    81
    82      private ClassLoader delegatationLoader;
    83  }